/**
 * 
 */
package svetoforTimer;

import java.util.TimerTask;

import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

public class SmartTimer implements EventProvider {
	/**
	 * @unimod.event.descr 5 seconds happened
	 */

	public static final String E201 = "e201";

	/**
	 * @unimod.event.descr 0.1 seconds happened
	 */
	public static final String E301 = "e301";

	private java.util.Timer t1;

	private java.util.Timer t2;

	private ModelEngine engine;

	public void init(ModelEngine engine) {
		this.engine = engine;

		t1 = new java.util.Timer(false);
		t1.schedule(new TimerTask() {
			public void run() {
				SmartTimer.this.engine.getEventManager().handle(
						new Event(E201), StateMachineContextImpl.create());
			}
		}, 500, 5000);
		t2 = new java.util.Timer(false);
		t2.schedule(new TimerTask() {
			public void run() {
				SmartTimer.this.engine.getEventManager().handle(
						new Event(E301), StateMachineContextImpl.create());
			}
		}, 100, 100);
	}

	public void dispose() {
		t1.cancel();
		t2.cancel();
	}
}
